Problem running Ilastik AutoContext pixel classifier from Fiji

Hi,

I have an AutoContext ilastik classifier that I trained with Ilastik v1.3.3b2
I can smoothly run it with previous version of Ilastik plugins (Ilastik4ij-1.7.0), using the “plugins>ilastik>run Pixel Classification Prediction” but it does not work with the updated version (ilastik4ij-1.8.0) and I get the following error message:

[ERROR] ERROR 2020-11-23 10:19:14,756 log_exception 28024 17396 Traceback (most recent call last):
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\applets\dataExport\dataExportApplet.py", line 263, in _configure_operator_with_parsed_args
[ERROR]     source_index = source_choices.index(export_source)
[ERROR] ValueError: 'probabilities' is not in list
[ERROR] 
[ERROR] During handling of the above exception, another exception occurred:
[ERROR] 
[ERROR] Traceback (most recent call last):
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\shell\projectManager.py", line 441, in _loadProject
[ERROR]     self.workflow.onProjectLoaded( self )
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\workflows\newAutocontext\newAutocontextWorkflow.py", line 431, in onProjectLoaded
[ERROR]     self.dataExportApplet.configure_operator_with_parsed_args( self._batch_export_args )
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\applets\dataExport\dataExportApplet.py", line 240, in configure_operator_with_parsed_args
[ERROR]     self._configure_operator_with_parsed_args(parsed_args, opDataExport)
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\applets\dataExport\dataExportApplet.py", line 266, in _configure_operator_with_parsed_args
[ERROR]     "Valid options are: {}".format( parsed_args.export_source, source_choices ))
[ERROR] Exception: Invalid option for --export_source: 'Probabilities'
[ERROR] Valid options are: ['probabilities stage 2', 'simple segmentation stage 2', 'uncertainty stage 2', 'features stage 2', 'labels stage 2', 'input stage 2', 'probabilities stage 1', 'simple segmentation stage 1', 'uncertainty stage 1', 'features stage 1', 'labels stage 1', 'input stage 1', 'probabilities all stages']
[ERROR] 
[ERROR] ERROR 2020-11-23 10:19:14,756 log_exception 28024 17396 Project could not be loaded due to the exception shown above.
[ERROR] Aborting Project Open Action
[ERROR] ERROR 2020-11-23 10:19:20,189 excepthooks 28024 17396 Unhandled exception in thread: 'MainThread'
[ERROR] ERROR 2020-11-23 10:19:20,190 excepthooks 28024 17396 Traceback (most recent call last):
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\applets\dataExport\dataExportApplet.py", line 263, in _configure_operator_with_parsed_args
[ERROR]     source_index = source_choices.index(export_source)
[ERROR] ValueError: 'probabilities' is not in list
[ERROR] 
[ERROR] During handling of the above exception, another exception occurred:
[ERROR] 
[ERROR] Traceback (most recent call last):
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik.py", line 139, in <module>
[ERROR]     main()
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik.py", line 133, in main
[ERROR]     hShell = ilastik_main.main(parsed_args, workflow_cmdline_args)
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik_main.py", line 218, in main
[ERROR]     f(shell)
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik_main.py", line 396, in loadProject
[ERROR]     shell.openProjectFile(path, parsed_args.readonly)
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\shell\headless\headlessShell.py", line 117, in openProjectFile
[ERROR]     self.projectManager._loadProject(hdf5File, projectFilePath, readOnly)
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\lazyflow\lazyflow\utility\timer.py", line 153, in wrapper
[ERROR]     return func(*args, **kwargs)
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\shell\projectManager.py", line 441, in _loadProject
[ERROR]     self.workflow.onProjectLoaded( self )
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\workflows\newAutocontext\newAutocontextWorkflow.py", line 431, in onProjectLoaded
[ERROR]     self.dataExportApplet.configure_operator_with_parsed_args( self._batch_export_args )
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\applets\dataExport\dataExportApplet.py", line 240, in configure_operator_with_parsed_args
[ERROR]     self._configure_operator_with_parsed_args(parsed_args, opDataExport)
[ERROR]   File "C:\Program Files\ilastik-1.3.3b2\ilastik-meta\ilastik\ilastik\applets\dataExport\dataExportApplet.py", line 266, in _configure_operator_with_parsed_args
[ERROR]     "Valid options are: {}".format( parsed_args.export_source, source_choices ))
[ERROR] Exception: Invalid option for --export_source: 'Probabilities'
[ERROR] Valid options are: ['probabilities stage 2', 'simple segmentation stage 2', 'uncertainty stage 2', 'features stage 2', 'labels stage 2', 'input stage 2', 'probabilities stage 1', 'simple segmentation stage 1', 'uncertainty stage 1', 'features stage 1', 'labels stage 1', 'input stage 1', 'probabilities all stages']
[ERROR] 

With the new version I cannot run any Autocontext classifier , including one trained with the latest stable version: 1.3.3post3.

It seems that parameters names have changed.
Is there any way to run Autocontext classifiers from Fiji now ?

Thanks
Ofra

Hi @Ofra_Golani,

at some point we enforced in our plugin that the export source shall be named. And since the names between pixel classification and autocontext don’t match up, this broke :confused:

I’ve opened a PR in our plugin repository to enable “proper” autocontext support (before, it sort of worked by accident, and also only if you exported Probabilities).

1 Like

Thanks @k-dominik,

Thanks for the PR. Being able to run Autocontext from Fiji would be great (as well as all other ilastik classifiers, especially Multicut)

In the meanwhile, is there an “official”/“non-official” link to Ilastik4ij-1.7.0.jar
So I can point to it when publishing the results and code that are based on this classifier?

Thanks
Ofra

Hi @Ofra_Golani,

sure, sorry. I meant to post it. Here’s the link to the archive: https://sites.imagej.net/Ilastik/plugins/

Hey Ofra, just to let you know - autocontext is now included in the latest plugin version (1.8.1)

1 Like

Thanks @k-dominik, this is great !
What about running multicut prediction from Fiji? will this be possible?

we currently have a PR to add this feature. Once this is through we’ll update the plugin!